
// VTC1020_CAN_UtilityDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VTC1020_CAN_Utility.h"
#include "VTC1020_CAN_UtilityDlg.h"
#include "VTC1020_CAN.h"
#include "Useful_Function.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define _RECEIVE_BLOCK_


CWinThread* g_pCWinThread = NULL;
UINT __cdecl MyControllingFunction( LPVOID pParam );

unsigned __int64 g_nTotalSend = 0;
unsigned __int64 g_nTotalErrorSend = 0;
unsigned __int64 g_nTotalReceive = 0;
CString g_strTotalSend;
CString g_strTotalErrorSend;
CString g_strTotalReceive;

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CVTC1020_CAN_UtilityDlg dialog




CVTC1020_CAN_UtilityDlg::CVTC1020_CAN_UtilityDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVTC1020_CAN_UtilityDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVTC1020_CAN_UtilityDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, m_CComboBox_CANSpeed);
	DDX_Control(pDX, IDC_COMBO2, m_CComboBox_FilterNumber);
	DDX_Control(pDX, IDC_EDIT1, m_CEdit_FilterID);
	DDX_Control(pDX, IDC_EDIT2, m_CEdit_FilterMaskID);
	DDX_Control(pDX, IDC_COMBO3, m_CComboBox_FilterMode);
	DDX_Control(pDX, IDC_COMBO4, m_CComboBox_FilterScale);
	DDX_Control(pDX, IDC_COMBO5, m_CComboBox_FilterActivation);
	DDX_Control(pDX, IDC_EDIT3, m_CEdit_UserID);
	DDX_Control(pDX, IDC_COMBO6, m_CComboBox_Format);
	DDX_Control(pDX, IDC_COMBO7, m_CComboBox_Type);
	DDX_Control(pDX, IDC_COMBO8, m_CComboBox_Length);
	DDX_Control(pDX, IDC_EDIT4, m_CEdit_CANMessage1);
	DDX_Control(pDX, IDC_EDIT5, m_CEdit_CANMessage2);
	DDX_Control(pDX, IDC_EDIT6, m_CEdit_CANMessage3);
	DDX_Control(pDX, IDC_EDIT7, m_CEdit_CANMessage4);
	DDX_Control(pDX, IDC_EDIT8, m_CEdit_CANMessage5);
	DDX_Control(pDX, IDC_EDIT9, m_CEdit_CANMessage6);
	DDX_Control(pDX, IDC_EDIT10, m_CEdit_CANMessage7);
	DDX_Control(pDX, IDC_EDIT11, m_CEdit_CANMessage8);
	DDX_Control(pDX, IDC_EDIT12, m_CEdit_Timer);
	DDX_Control(pDX, IDC_LIST1, m_CListBox_ReceiveCANMessage);
	DDX_Control(pDX, IDC_EDIT13, m_CEdit_ErrorMessage);
	DDX_Control(pDX, IDC_EDIT14, m_CEdit_TotalSend);
	DDX_Control(pDX, IDC_EDIT15, m_CEdit_TotalErrorSend);
	DDX_Control(pDX, IDC_EDIT16, m_CEdit_TotalReceive);
}

BEGIN_MESSAGE_MAP(CVTC1020_CAN_UtilityDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, &CVTC1020_CAN_UtilityDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CVTC1020_CAN_UtilityDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CVTC1020_CAN_UtilityDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CVTC1020_CAN_UtilityDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CVTC1020_CAN_UtilityDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CVTC1020_CAN_UtilityDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CVTC1020_CAN_UtilityDlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CVTC1020_CAN_UtilityDlg::OnBnClickedButton8)
END_MESSAGE_MAP()


// CVTC1020_CAN_UtilityDlg message handlers

BOOL CVTC1020_CAN_UtilityDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	m_CComboBox_CANSpeed.ResetContent();
	m_CComboBox_CANSpeed.InsertString(0,  "12.5 kbps");
	m_CComboBox_CANSpeed.InsertString(1,  "16 kbps");
	m_CComboBox_CANSpeed.InsertString(2,  "20 kbps");
	m_CComboBox_CANSpeed.InsertString(3,  "25 kbps");
	m_CComboBox_CANSpeed.InsertString(4,  "31.25 kbps");
	m_CComboBox_CANSpeed.InsertString(5,  "40 kbps");
	m_CComboBox_CANSpeed.InsertString(6,  "50 kbps");
	m_CComboBox_CANSpeed.InsertString(7,  "62.5 kbps");
	m_CComboBox_CANSpeed.InsertString(8,  "80 kbps");
	m_CComboBox_CANSpeed.InsertString(9,  "100 kbps");
	m_CComboBox_CANSpeed.InsertString(10, "125 kbps");
	m_CComboBox_CANSpeed.InsertString(11, "200 kbps");
	m_CComboBox_CANSpeed.InsertString(12, "250 kbps");
	m_CComboBox_CANSpeed.InsertString(13, "400 kbps");
	m_CComboBox_CANSpeed.InsertString(14, "500 kbps");
	m_CComboBox_CANSpeed.InsertString(15, "1000 kbps");
	m_CComboBox_CANSpeed.SetCurSel(12);

	m_CComboBox_FilterNumber.ResetContent();
	m_CComboBox_FilterNumber.InsertString(0, "0");
	m_CComboBox_FilterNumber.InsertString(1, "1");
	m_CComboBox_FilterNumber.InsertString(2, "2");
	m_CComboBox_FilterNumber.InsertString(3, "3");
	m_CComboBox_FilterNumber.InsertString(4, "4");
	m_CComboBox_FilterNumber.InsertString(5, "5");
	m_CComboBox_FilterNumber.InsertString(6, "6");
	m_CComboBox_FilterNumber.InsertString(7, "7");
	m_CComboBox_FilterNumber.InsertString(8, "8");
	m_CComboBox_FilterNumber.InsertString(9, "9");
	m_CComboBox_FilterNumber.InsertString(10, "10");
	m_CComboBox_FilterNumber.InsertString(11, "11");
	m_CComboBox_FilterNumber.InsertString(12, "12");
	m_CComboBox_FilterNumber.InsertString(13, "13");
	m_CComboBox_FilterNumber.SetCurSel(0);

	m_CComboBox_FilterMode.ResetContent();
	m_CComboBox_FilterMode.InsertString(0, "Mask");
	m_CComboBox_FilterMode.InsertString(1, "List");
	m_CComboBox_FilterMode.SetCurSel(0);

	m_CComboBox_FilterScale.ResetContent();
	m_CComboBox_FilterScale.InsertString(0, "Two 16-bit");
	m_CComboBox_FilterScale.InsertString(1, "One 32-bit");
	m_CComboBox_FilterScale.SetCurSel(1);

	m_CComboBox_FilterActivation.ResetContent();
	m_CComboBox_FilterActivation.InsertString(0, "Disable");
	m_CComboBox_FilterActivation.InsertString(1, "Enable");
	m_CComboBox_FilterActivation.SetCurSel(1);

	m_CEdit_FilterID.SetWindowText("00000000");
	m_CEdit_FilterMaskID.SetWindowText("00000000");

	m_CComboBox_Format.ResetContent();
	m_CComboBox_Format.InsertString(0, "Standard (11bit ID)");
	m_CComboBox_Format.InsertString(1, "Extended (29bit ID)");
	m_CComboBox_Format.SetCurSel(0);

	m_CComboBox_Type.ResetContent();
	m_CComboBox_Type.InsertString(0, "Data");
	m_CComboBox_Type.InsertString(1, "Remote");
	m_CComboBox_Type.SetCurSel(0);

	m_CComboBox_Length.ResetContent();
	m_CComboBox_Length.InsertString(0, "0");
	m_CComboBox_Length.InsertString(1, "1");
	m_CComboBox_Length.InsertString(2, "2");
	m_CComboBox_Length.InsertString(3, "3");
	m_CComboBox_Length.InsertString(4, "4");
	m_CComboBox_Length.InsertString(5, "5");
	m_CComboBox_Length.InsertString(6, "6");
	m_CComboBox_Length.InsertString(7, "7");
	m_CComboBox_Length.InsertString(8, "8");
	m_CComboBox_Length.SetCurSel(8);

	m_CEdit_UserID.SetWindowText("7FF");     // 11bit or 29bit

	m_CEdit_CANMessage1.SetWindowText("19");
	m_CEdit_CANMessage2.SetWindowText("20");
	m_CEdit_CANMessage3.SetWindowText("3A");
	m_CEdit_CANMessage4.SetWindowText("4B");
	m_CEdit_CANMessage5.SetWindowText("5C");
	m_CEdit_CANMessage6.SetWindowText("6D");
	m_CEdit_CANMessage7.SetWindowText("7E");
	m_CEdit_CANMessage8.SetWindowText("8F");

	m_CEdit_Timer.SetWindowText("1000");

	g_nTotalSend = 0;
	g_nTotalErrorSend = 0;
	g_nTotalReceive = 0;
	g_strTotalSend.Format("%I64u", g_nTotalSend);
	g_strTotalErrorSend.Format("%I64u", g_nTotalErrorSend);
	g_strTotalReceive.Format("%I64u", g_nTotalReceive);
	m_CEdit_TotalSend.SetWindowText(g_strTotalSend);
	m_CEdit_TotalErrorSend.SetWindowText(g_strTotalErrorSend);
	m_CEdit_TotalReceive.SetWindowText(g_strTotalReceive);

	int nMajorVersion = 0;
	int nMinorVersion = 0;
	CAN_Get_DLL_Version(&nMajorVersion, &nMinorVersion);
	CString strVer;
	strVer.Format("DLL ver %d.%d", nMajorVersion, nMinorVersion);
	AddRecevMessage(strVer);

	DisableButtonWhenClose();

	if( 1 != CAN_Connect() )
	{
		MessageBox("Connect to CAN BUS device failed!!!");
	}
	else
	{
		AddErrorMessage("Connect to CAN BUS device success.");

		g_pCWinThread = AfxBeginThread(MyControllingFunction, this);
		if( NULL == g_pCWinThread )
		{
			AddErrorMessage("Create a new thread failed!!!");
			return TRUE;
		}

		EnableButtonWhenOpen();
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVTC1020_CAN_UtilityDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVTC1020_CAN_UtilityDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVTC1020_CAN_UtilityDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

bool g_bRunThread = false;

UINT __cdecl MyControllingFunction( LPVOID pParam )
{
	CVTC1020_CAN_UtilityDlg *pCVTC1020_CAN_UtilityDlg = (CVTC1020_CAN_UtilityDlg *)pParam;

	g_bRunThread = true;

	while ( g_bRunThread )
	{
		pCVTC1020_CAN_UtilityDlg->MyRecevMessage();
	}

	::AfxEndThread(0);

	return 0;
}

void CVTC1020_CAN_UtilityDlg::MyRecevMessage()
{
	can_msg_t msg;

#ifdef _RECEIVE_BLOCK_
	if( 1 == CAN_Receive_Block(&msg) )
#else
	if( 1 == CAN_Receive(&msg) )
#endif
	{
		SYSTEMTIME sysTime;
		::GetLocalTime(&sysTime);

		g_nTotalReceive++;
		g_strTotalReceive.Format("%I64u", g_nTotalReceive);
		m_CEdit_TotalReceive.SetWindowText(g_strTotalReceive);

		// CANmsg
		CString strCANmsg;
		strCANmsg.Format("%I64u %02d:%02d:%02d:%03d <== ID:0x%X IDE:%d RTR:%d DLC:%d DATA: ",
			g_nTotalReceive, sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds, msg.id, msg.ide, msg.rtr, msg.dlc);

		// DATA
		CString strTemp;
		for ( int i=0 ; i<msg.dlc && i<8 ; i++ )
		{
			strTemp.Format("0x%02X ", msg.data[i]);
			strCANmsg += strTemp;
		}

		AddRecevMessage(strCANmsg);
	}
}

void CVTC1020_CAN_UtilityDlg::OnDestroy()
{
	CDialog::OnDestroy();

	DisableButtonWhenClose();

	CAN_Disconnect();

	if( g_pCWinThread && g_bRunThread )
	{
		g_bRunThread = false;
		AddErrorMessage("Wait for thread end.");
		::WaitForSingleObject(g_pCWinThread->m_hThread, 1000);
	}

	AddErrorMessage("Close.");
}

void CVTC1020_CAN_UtilityDlg::AddErrorMessage(CString ErrorMessage)
{
	m_CEdit_ErrorMessage.SetWindowText(ErrorMessage);
}

void CVTC1020_CAN_UtilityDlg::AddRecevMessage(CString RecevMessage)
{
	int nCount = m_CListBox_ReceiveCANMessage.GetCount();
	if( nCount > 13 )
	{
		m_CListBox_ReceiveCANMessage.DeleteString(0);
	}

	nCount = m_CListBox_ReceiveCANMessage.GetCount();
	m_CListBox_ReceiveCANMessage.InsertString(nCount, RecevMessage);
}

void CVTC1020_CAN_UtilityDlg::OnTimer(UINT_PTR nIDEvent)
{
	if( 1 == nIDEvent )
	{
		OnBnClickedButton6();
	}

	CDialog::OnTimer(nIDEvent);
}

void CVTC1020_CAN_UtilityDlg::OnBnClickedButton1()
{
	int nCurSel = m_CComboBox_CANSpeed.GetCurSel();
	int nResult = CAN_SetCANSpeed(nCurSel);
	if( 1 == nResult )
	{
		CString temp;
		switch(nCurSel)
		{
		case 0:  temp.Format("Set CAN Speed (12.5 kbps) success."); break;
		case 1:  temp.Format("Set CAN Speed (16 kbps) success."); break;
		case 2:  temp.Format("Set CAN Speed (20 kbps) success."); break;
		case 3:  temp.Format("Set CAN Speed (25 kbps) success."); break;
		case 4:  temp.Format("Set CAN Speed (31.25 kbps) success."); break;
		case 5:  temp.Format("Set CAN Speed (40 kbps) success."); break;
		case 6:  temp.Format("Set CAN Speed (50 kbps) success."); break;
		case 7:  temp.Format("Set CAN Speed (62.5 kbps) success."); break;
		case 8:  temp.Format("Set CAN Speed (80 kbps) success."); break;
		case 9:  temp.Format("Set CAN Speed (100 kbps) success."); break;
		case 10: temp.Format("Set CAN Speed (125 kbps) success."); break;
		case 11: temp.Format("Set CAN Speed (200 kbps) success."); break;
		case 12: temp.Format("Set CAN Speed (250 kbps) success."); break;
		case 13: temp.Format("Set CAN Speed (400 kbps) success."); break;
		case 14: temp.Format("Set CAN Speed (500 kbps) success."); break;
		case 15: temp.Format("Set CAN Speed (1000 kbps) success."); break;
		}

		AddErrorMessage(temp);
	}
	else
	{
		CString temp;
		switch(nCurSel)
		{
		case 0:  temp.Format("Set CAN Speed (12.5 kbps) failed!!!"); break;
		case 1:  temp.Format("Set CAN Speed (16 kbps) failed!!!"); break;
		case 2:  temp.Format("Set CAN Speed (20 kbps) failed!!!"); break;
		case 3:  temp.Format("Set CAN Speed (25 kbps) failed!!!"); break;
		case 4:  temp.Format("Set CAN Speed (31.25 kbps) failed!!!"); break;
		case 5:  temp.Format("Set CAN Speed (40 kbps) failed!!!"); break;
		case 6:  temp.Format("Set CAN Speed (50 kbps) failed!!!"); break;
		case 7:  temp.Format("Set CAN Speed (62.5 kbps) failed!!!"); break;
		case 8:  temp.Format("Set CAN Speed (80 kbps) failed!!!"); break;
		case 9:  temp.Format("Set CAN Speed (100 kbps) failed!!!"); break;
		case 10: temp.Format("Set CAN Speed (125 kbps) failed!!!"); break;
		case 11: temp.Format("Set CAN Speed (200 kbps) failed!!!"); break;
		case 12: temp.Format("Set CAN Speed (250 kbps) failed!!!"); break;
		case 13: temp.Format("Set CAN Speed (400 kbps) failed!!!"); break;
		case 14: temp.Format("Set CAN Speed (500 kbps) failed!!!"); break;
		case 15: temp.Format("Set CAN Speed (1000 kbps) failed!!!"); break;
		}

		AddErrorMessage(temp);
	}
}

void CVTC1020_CAN_UtilityDlg::OnBnClickedButton2()
{
	int nResult = CAN_SetCANStopTransmit();
	if( 1 == nResult )
	{
		AddErrorMessage("Stop Transmit success.");
	}
	else
	{
		AddErrorMessage("Stop Transmit failed!!!");
	}
}

void CVTC1020_CAN_UtilityDlg::OnBnClickedButton3()
{
	int nResult = CAN_SetCANClearReceiveFIFO();
	if( 1 == nResult )
	{
		AddErrorMessage("Clear Receive FIFO success.");
	}
	else
	{
		AddErrorMessage("Clear Receive FIFO failed!!!");
	}
}

void CVTC1020_CAN_UtilityDlg::OnBnClickedButton4()
{
	unsigned char byErrorCode = 0;
	int nResult = CAN_GetCANErrorCode(&byErrorCode);
	if( 1 == nResult )
	{
		switch( byErrorCode )
		{
		case 0x00:  AddErrorMessage("No error."); break;
		case 0x10:  AddErrorMessage("Stuff error!!!"); break;
		case 0x20:  AddErrorMessage("Form error!!!"); break;
		case 0x30:  AddErrorMessage("ACK error!!!"); break;
		case 0x40:  AddErrorMessage("Bit Recessive error!!!"); break;
		case 0x50:  AddErrorMessage("Bit Dominant error!!!"); break;
		case 0x60:  AddErrorMessage("CRC error!!!"); break;
		case 0x70:  AddErrorMessage("Software set error!!!"); break;
		case 0xFF:  AddErrorMessage("Command error!!!"); break;
		default:
			{
				CString strError;
				strError.Format("Undefined error!!! (0x%X).", byErrorCode);
				AddErrorMessage(strError);
				break;
			}
		}
	}
	else
	{
		AddErrorMessage("Get CAN ErrorCode failed!!!");
	}
}

void CVTC1020_CAN_UtilityDlg::OnBnClickedButton5()
{
	can_filter_t filter;
	memset(&filter, 0, sizeof(filter));

	filter.num = m_CComboBox_FilterNumber.GetCurSel();

	char szTemp[64];

	memset(szTemp, 0, sizeof(szTemp));
	m_CEdit_FilterID.GetWindowText(szTemp, sizeof(szTemp));
	filter.id = transfer_string_to_hex( (unsigned char*)szTemp);

	memset(szTemp, 0, sizeof(szTemp));
	m_CEdit_FilterMaskID.GetWindowText(szTemp, sizeof(szTemp));
	filter.mid = transfer_string_to_hex( (unsigned char*)szTemp);

	filter.mode = m_CComboBox_FilterMode.GetCurSel();
	filter.scale = m_CComboBox_FilterScale.GetCurSel();
	filter.act = m_CComboBox_FilterActivation.GetCurSel();

	int nResult = CAN_SetCANFilter(&filter);
	if( nResult == 1 )
		AddErrorMessage("Set CAN filter success.");
	else
		AddErrorMessage("Set CAN filter failed!!!");
}

void CVTC1020_CAN_UtilityDlg::OnBnClickedButton6()
{
	can_msg_t msg;
	memset(&msg, 0, sizeof(msg));

	char szID[64];
	memset(szID, 0, sizeof(szID));
	m_CEdit_UserID.GetWindowText(szID, sizeof(szID));
	msg.id = transfer_string_to_hex( (unsigned char*)szID );

	msg.ide = m_CComboBox_Format.GetCurSel();
	msg.rtr = m_CComboBox_Type.GetCurSel();
	msg.dlc = m_CComboBox_Length.GetCurSel();

	char szTemp1[16]; memset(szTemp1, 0, sizeof(szTemp1)); m_CEdit_CANMessage1.GetWindowText(szTemp1, sizeof(szTemp1));
	char szTemp2[16]; memset(szTemp2, 0, sizeof(szTemp2)); m_CEdit_CANMessage2.GetWindowText(szTemp2, sizeof(szTemp2));
	char szTemp3[16]; memset(szTemp3, 0, sizeof(szTemp3)); m_CEdit_CANMessage3.GetWindowText(szTemp3, sizeof(szTemp3));
	char szTemp4[16]; memset(szTemp4, 0, sizeof(szTemp4)); m_CEdit_CANMessage4.GetWindowText(szTemp4, sizeof(szTemp4));
	char szTemp5[16]; memset(szTemp5, 0, sizeof(szTemp5)); m_CEdit_CANMessage5.GetWindowText(szTemp5, sizeof(szTemp5));
	char szTemp6[16]; memset(szTemp6, 0, sizeof(szTemp6)); m_CEdit_CANMessage6.GetWindowText(szTemp6, sizeof(szTemp6));
	char szTemp7[16]; memset(szTemp7, 0, sizeof(szTemp7)); m_CEdit_CANMessage7.GetWindowText(szTemp7, sizeof(szTemp7));
	char szTemp8[16]; memset(szTemp8, 0, sizeof(szTemp8)); m_CEdit_CANMessage8.GetWindowText(szTemp8, sizeof(szTemp8));

	msg.data[0] = transfer_string_to_hex( (unsigned char*)szTemp1);
	msg.data[1] = transfer_string_to_hex( (unsigned char*)szTemp2);
	msg.data[2] = transfer_string_to_hex( (unsigned char*)szTemp3);
	msg.data[3] = transfer_string_to_hex( (unsigned char*)szTemp4);
	msg.data[4] = transfer_string_to_hex( (unsigned char*)szTemp5);
	msg.data[5] = transfer_string_to_hex( (unsigned char*)szTemp6);
	msg.data[6] = transfer_string_to_hex( (unsigned char*)szTemp7);
	msg.data[7] = transfer_string_to_hex( (unsigned char*)szTemp8);

	if( msg.ide == 0 )
	{
		msg.id = msg.id & 0x7FF;

		char szID[32];
		memset(szID, 0, sizeof(szID));
		sprintf_s(szID, sizeof(szID), "%X", msg.id);
		m_CEdit_UserID.SetWindowText(szID);
	}
	else
	{
		msg.id = msg.id & 0x1FFFFFFF;

		char szID[32];
		memset(szID, 0, sizeof(szID));
		sprintf_s(szID, sizeof(szID), "%X", msg.id);
		m_CEdit_UserID.SetWindowText(szID);
	}

	// Time
	SYSTEMTIME sysTime;
	::GetLocalTime(&sysTime);

	int nResult = CAN_SetCANSendMessage(&msg);
	switch(nResult)
	{
	case 1:
		g_nTotalSend++;
		g_strTotalSend.Format("%I64u", g_nTotalSend);
		m_CEdit_TotalSend.SetWindowText(g_strTotalSend);
		break;
	default:
		g_nTotalErrorSend++;
		g_strTotalErrorSend.Format("%I64u", g_nTotalErrorSend);
		m_CEdit_TotalErrorSend.SetWindowText(g_strTotalErrorSend);
		break;
	}

	switch(nResult)
	{
	case 0:
		{
			CString strError;
			strError.Format("%I64u %02d:%02d:%02d:%03d ==> Transmit Fail!!!", g_nTotalErrorSend, sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds);
			AddRecevMessage(strError);
		}
		break;
	case 1:
		{
			// CANmsg
			CString strCANmsg;
			strCANmsg.Format("%I64u %02d:%02d:%02d:%03d ==> ID:0x%X IDE:%d RTR:%d DLC:%d DATA: ",
				g_nTotalSend, sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds, msg.id, msg.ide, msg.rtr, msg.dlc);

			// DATA
			CString strTemp;
			for ( int i=0 ; i<msg.dlc && i<8 ; i++ )
			{
				strTemp.Format("0x%02X ", msg.data[i]);
				strCANmsg += strTemp;
			}

			AddRecevMessage(strCANmsg);
		}
		break;
	case 2:
		{
			CString strError;
			strError.Format("%I64u %02d:%02d:%02d:%03d ==> Transmit Pending!!!", g_nTotalErrorSend, sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds);
			AddRecevMessage(strError);
		}
		break;
	case 3:
		{
			CString strError;
			strError.Format("%I64u %02d:%02d:%02d:%03d ==> Transmit Buffer full!!!", g_nTotalErrorSend, sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds);
			AddRecevMessage(strError);
		}
		break;
	default:
		{
			CString strError;
			strError.Format("%I64u %02d:%02d:%02d:%03d ==> Can't send message!!!", g_nTotalErrorSend, sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds);
			AddRecevMessage(strError);
		}
		break;
	}
}

// ================================================================================================================================================
// Auto Send
// ================================================================================================================================================
BOOL g_IsAutoSend = FALSE;

void CVTC1020_CAN_UtilityDlg::OnBnClickedButton7()
{
	if( TRUE == g_IsAutoSend )
	{
		this->KillTimer(1);

		CWnd *pButton10 = this->GetDlgItem(IDC_BUTTON7);
		pButton10->SetWindowText("Auto Send");

		g_IsAutoSend = FALSE;
	}
	else
	{
		CString strTime;
		m_CEdit_Timer.GetWindowText(strTime);
		unsigned int nTime = atoi( strTime );
		this->SetTimer(1, nTime, NULL);

		CWnd *pButton10 = this->GetDlgItem(IDC_BUTTON7);
		pButton10->SetWindowText("Stop Send");

		g_IsAutoSend = TRUE;
	}
}

// ================================================================================================================================================
// Clear all messages
// ================================================================================================================================================
void CVTC1020_CAN_UtilityDlg::OnBnClickedButton8()
{
	g_nTotalSend = 0;
	g_nTotalErrorSend = 0;
	g_nTotalReceive = 0;

	g_strTotalSend.Format("%I64u", g_nTotalSend);
	g_strTotalErrorSend.Format("%I64u", g_nTotalErrorSend);
	g_strTotalReceive.Format("%I64u", g_nTotalReceive);

	m_CEdit_TotalSend.SetWindowText(g_strTotalSend);
	m_CEdit_TotalErrorSend.SetWindowText(g_strTotalErrorSend);
	m_CEdit_TotalReceive.SetWindowText(g_strTotalReceive);

	m_CListBox_ReceiveCANMessage.ResetContent();
	m_CEdit_ErrorMessage.SetWindowText("");
}

// ================================================================================================================================================
// Enable or disable all buttons
// ================================================================================================================================================
void CVTC1020_CAN_UtilityDlg::DisableButtonWhenClose()
{
	CWnd *pButton1 = this->GetDlgItem(IDC_BUTTON1);
	pButton1->EnableWindow(FALSE);

	CWnd *pButton2 = this->GetDlgItem(IDC_BUTTON2);
	pButton2->EnableWindow(FALSE);

	CWnd *pButton3 = this->GetDlgItem(IDC_BUTTON3);
	pButton3->EnableWindow(FALSE);

	CWnd *pButton4 = this->GetDlgItem(IDC_BUTTON4);
	pButton4->EnableWindow(FALSE);

	CWnd *pButton5 = this->GetDlgItem(IDC_BUTTON5);
	pButton5->EnableWindow(FALSE);

	CWnd *pButton6 = this->GetDlgItem(IDC_BUTTON6);
	pButton6->EnableWindow(FALSE);

	CWnd *pButton7 = this->GetDlgItem(IDC_BUTTON7);
	pButton7->EnableWindow(FALSE);
}

void CVTC1020_CAN_UtilityDlg::EnableButtonWhenOpen()
{
	CWnd *pButton1 = this->GetDlgItem(IDC_BUTTON1);
	pButton1->EnableWindow(TRUE);

	CWnd *pButton2 = this->GetDlgItem(IDC_BUTTON2);
	pButton2->EnableWindow(TRUE);

	CWnd *pButton3 = this->GetDlgItem(IDC_BUTTON3);
	pButton3->EnableWindow(TRUE);

	CWnd *pButton4 = this->GetDlgItem(IDC_BUTTON4);
	pButton4->EnableWindow(TRUE);

	CWnd *pButton5 = this->GetDlgItem(IDC_BUTTON5);
	pButton5->EnableWindow(TRUE);

	CWnd *pButton6 = this->GetDlgItem(IDC_BUTTON6);
	pButton6->EnableWindow(TRUE);

	CWnd *pButton7 = this->GetDlgItem(IDC_BUTTON7);
	pButton7->EnableWindow(TRUE);
}
