// DialogConfigTab1.cpp : @
//

#include "stdafx.h"
#include "VTC1020_Utility.h"
#include "DialogConfigTab1.h"
#include "VTC1020.h"
#include "VTC1020_UtilityDlg.h"


// CDialogConfigTab1 ܤ

IMPLEMENT_DYNAMIC(CDialogConfigTab1, CDialog)

CDialogConfigTab1::CDialogConfigTab1(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogConfigTab1::IDD, pParent)
{
	m_isDoCommand = FALSE;
}

CDialogConfigTab1::~CDialogConfigTab1()
{
}

void CDialogConfigTab1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_CEdit_MCUversion);
	DDX_Control(pDX, IDC_EDIT2, m_CEdit_Ignition);
	DDX_Control(pDX, IDC_EDIT3, m_CEdit_SupplyVoltage);
	DDX_Control(pDX, IDC_EDIT4, m_CEdit_WWAN_Enable);
	DDX_Control(pDX, IDC_EDIT5, m_CEdit_WWAN_Wakeup_Enable);
	DDX_Control(pDX, IDC_EDIT6, m_CEdit_WiFi);
	DDX_Control(pDX, IDC_EDIT7, m_CEdit_GPS_Status);
	DDX_Control(pDX, IDC_EDIT8, m_CEdit_WDT_Enable);
	DDX_Control(pDX, IDC_EDIT9, m_CEdit_WDT_Timeout);
	DDX_Control(pDX, IDC_EDIT10, m_CEdit_CANSwitchStatus);
	DDX_Control(pDX, IDC_EDIT11, m_CEdit_AudioSwitchStatus);
	DDX_Control(pDX, IDC_EDIT12, m_CEdit_InputFrequency);
	DDX_Control(pDX, IDC_COMBO1, m_CComboBox_WWAN_Enable);
	DDX_Control(pDX, IDC_COMBO2, m_CComboBox_WWAN_Wakeup_Enable);
	DDX_Control(pDX, IDC_COMBO3, m_CComboBox_WiFi);
	DDX_Control(pDX, IDC_COMBO4, m_CComboBox_GPS_Enable);
	DDX_Control(pDX, IDC_COMBO5, m_CComboBox_WDT_Enable);
	DDX_Control(pDX, IDC_COMBO6, m_CComboBox_WDT_Timeout);
	DDX_Control(pDX, IDC_COMBO7, m_CComboBox_CANSwitch);
	DDX_Control(pDX, IDC_COMBO8, m_CComboBox_AudioSwitch);
}


BEGIN_MESSAGE_MAP(CDialogConfigTab1, CDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, &CDialogConfigTab1::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CDialogConfigTab1::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CDialogConfigTab1::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CDialogConfigTab1::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CDialogConfigTab1::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CDialogConfigTab1::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CDialogConfigTab1::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CDialogConfigTab1::OnBnClickedButton8)
END_MESSAGE_MAP()


// CDialogConfigTab1 TBz`
BOOL CDialogConfigTab1::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here

	m_CComboBox_WWAN_Enable.ResetContent();
	m_CComboBox_WWAN_Enable.InsertString(0, TEXT("Disable"));
	m_CComboBox_WWAN_Enable.InsertString(1, TEXT("Enable"));
	m_CComboBox_WWAN_Enable.SetCurSel(1);

	m_CComboBox_WWAN_Wakeup_Enable.ResetContent();
	m_CComboBox_WWAN_Wakeup_Enable.InsertString(0, TEXT("Disable"));
	m_CComboBox_WWAN_Wakeup_Enable.InsertString(1, TEXT("Enable"));
	m_CComboBox_WWAN_Wakeup_Enable.SetCurSel(1);

	m_CComboBox_WiFi.ResetContent();
	m_CComboBox_WiFi.InsertString(0, TEXT("Disable"));
	m_CComboBox_WiFi.InsertString(1, TEXT("Enable"));
	m_CComboBox_WiFi.SetCurSel(1);

	m_CComboBox_GPS_Enable.ResetContent();
	m_CComboBox_GPS_Enable.InsertString(0, TEXT("Disable"));
	m_CComboBox_GPS_Enable.InsertString(1, TEXT("Enable"));
	m_CComboBox_GPS_Enable.SetCurSel(1);

	m_CComboBox_WDT_Enable.ResetContent();
	m_CComboBox_WDT_Enable.InsertString(0, TEXT("Disable"));
	m_CComboBox_WDT_Enable.InsertString(1, TEXT("Enable"));
	m_CComboBox_WDT_Enable.SetCurSel(0);

	m_CComboBox_WDT_Timeout.ResetContent();
	for ( int i=3 ; i<=255 ; i++ )
	{
		CString strWDT_Timeout;
		strWDT_Timeout.Format(TEXT("%0d"), i);
		m_CComboBox_WDT_Timeout.InsertString(i-3, strWDT_Timeout);
	}
	m_CComboBox_WDT_Timeout.SetCurSel(0);

	m_CComboBox_CANSwitch.ResetContent();
	m_CComboBox_CANSwitch.InsertString(0, TEXT("CAN2.0B"));
	m_CComboBox_CANSwitch.InsertString(1, TEXT("SAE J1939"));
	m_CComboBox_CANSwitch.SetCurSel(0);

	m_CComboBox_AudioSwitch.ResetContent();
	m_CComboBox_AudioSwitch.InsertString(0, TEXT("Driver"));
	m_CComboBox_AudioSwitch.InsertString(1, TEXT("Internal"));
	m_CComboBox_AudioSwitch.InsertString(2, TEXT("External"));
	m_CComboBox_AudioSwitch.SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDialogConfigTab1::OnTimer(UINT_PTR nIDEvent)
{
	if( 1 == nIDEvent )
	{
		KillTimer(1);

		switch( m_nStep )
		{
		case 0: fnGetMCUVersion();			m_nStep++; break;
		case 1: fnGetIgnitionStatus();		m_nStep++; break;
		case 2: fnGetSupplyVoltage();		m_nStep++; break;
		case 3: fnGetInputFrequency();		m_nStep++; break;
		case 4: fnGetWWANStatus();			m_nStep++; break;
		case 5: fnGetWiFiStatus();			m_nStep++; break;
		case 6: fnGetGPSStatus();			m_nStep++; break;
		case 7: fnGetWatchdogConfig();		m_nStep++; break;
		case 8: fnGetCANSwitchStatus();		m_nStep++; break;
		case 9: fnGetAudioSwitchStatus();	m_nStep++; break;
		default: break;
		}

		if( m_nStep < 10 )
			SetTimer(1, 50, NULL);
	}

	CDialog::OnTimer(nIDEvent);
}

void CDialogConfigTab1::Update()
{
	fnGetMCUVersion();
	fnGetIgnitionStatus();
	fnGetSupplyVoltage();
	fnGetInputFrequency();
}

void CDialogConfigTab1::fnGetMCUVersion()
{
	int nMCUVersion = 0;
	int nResult = GetMCUVersion(&nMCUVersion);
	if( nResult == 1 )
	{
		CString strMCUVersion;
		strMCUVersion.Format(TEXT("VT110R%02d"), nMCUVersion);
		m_CEdit_MCUversion.SetWindowText(strMCUVersion);
	}
	else
	{
		m_CEdit_MCUversion.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab1::fnGetIgnitionStatus()
{
	int nIgnitionStatus = 0;
	int nResult = GetIgnitionStatus(&nIgnitionStatus);
	if( nResult == 1 )
	{
		CString strIgnition;
		switch(nIgnitionStatus)
		{
		case 0: strIgnition = TEXT("OFF"); break;
		case 1: strIgnition = TEXT("ON"); break;
		default: strIgnition = TEXT("Undefined"); break;
		}
		m_CEdit_Ignition.SetWindowText(strIgnition);
	}
	else
	{
		m_CEdit_Ignition.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab1::fnGetSupplyVoltage()
{
	int nSupplyVoltage = 0;
	int nResult = GetSupplyVoltage(&nSupplyVoltage);
	if( nResult == 1 )
	{
		double fVoltage = (double)nSupplyVoltage/1000;
		CString strSupplyVoltage;
		strSupplyVoltage.Format(TEXT("%2.1f V"), fVoltage); 
		m_CEdit_SupplyVoltage.SetWindowText(strSupplyVoltage);
	}
	else
	{
		m_CEdit_SupplyVoltage.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab1::fnGetInputFrequency()
{
	int nInputFrequency;
	int nResult = GetInputFrequency(&nInputFrequency);
	if( nResult == 1 )
	{
		CString strInputFrequency;
		strInputFrequency.Format(TEXT("%d Hz"), nInputFrequency);
		m_CEdit_InputFrequency.SetWindowText(strInputFrequency);
	}
	else
	{
		m_CEdit_InputFrequency.SetWindowText(TEXT("? Hz"));
	}
}

void CDialogConfigTab1::fnGetWWANStatus()
{
	int nWWAN_Enable;
	int nWWAN_Wakeup_Enable;
	int nResult = GetWWANStatus(&nWWAN_Enable, &nWWAN_Wakeup_Enable);
	if( nResult == 1 )
	{
		CString strWWAN_Enable;
		switch(nWWAN_Enable)
		{
		case 0: strWWAN_Enable = TEXT("Disable"); break;
		case 1: strWWAN_Enable = TEXT("Enable"); break;
		default: strWWAN_Enable = TEXT("Undefined"); break;
		}
		m_CEdit_WWAN_Enable.SetWindowText(strWWAN_Enable);

		CString strWWAN_Wakeup_Enable;
		switch(nWWAN_Wakeup_Enable)
		{
		case 0: strWWAN_Wakeup_Enable = TEXT("Disable"); break;
		case 1: strWWAN_Wakeup_Enable = TEXT("Enable"); break;
		default: strWWAN_Wakeup_Enable = TEXT("Undefined"); break;
		}
		m_CEdit_WWAN_Wakeup_Enable.SetWindowText(strWWAN_Wakeup_Enable);
	}
	else
	{
		m_CEdit_WWAN_Enable.SetWindowText(TEXT("?"));
		m_CEdit_WWAN_Wakeup_Enable.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab1::fnGetWiFiStatus()
{
	int nWiFi;
	int nResult = GetWiFiStatus(&nWiFi);
	if( nResult == 1 )
	{
		switch(nWiFi)
		{
		case 0: m_CEdit_WiFi.SetWindowText(TEXT("Disable")); break;
		case 1: m_CEdit_WiFi.SetWindowText(TEXT("Enable")); break;
		default: m_CEdit_WiFi.SetWindowText(TEXT("Undefined")); break;
		}
	}
	else
	{
		m_CEdit_WiFi.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab1::fnGetGPSStatus()
{
	int nGPSStatus;
	int nResult = GetGPSStatus(&nGPSStatus);
	if( nResult == 1 )
	{
		CString strGPSStatus;
		switch(nGPSStatus)
		{
		case 0: strGPSStatus = TEXT("Disable"); break;
		case 1: strGPSStatus = TEXT("Enable"); break;
		default: strGPSStatus = TEXT("Undefined"); break;
		}
		m_CEdit_GPS_Status.SetWindowText(strGPSStatus);
	}
	else
	{
		m_CEdit_GPS_Status.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab1::fnGetWatchdogConfig()
{
	int nWDT_Enable;
	int nTimeout;
	int nResult = GetWatchdogConfig(&nWDT_Enable, &nTimeout);
	if( nResult == 1 )
	{
		CString strWDT_Enable;
		switch(nWDT_Enable)
		{
		case 0: strWDT_Enable = TEXT("Disable"); break;
		case 1: strWDT_Enable = TEXT("Enable"); break;
		default: strWDT_Enable = TEXT("Undefined"); break;
		}
		m_CEdit_WDT_Enable.SetWindowText(strWDT_Enable);

		CString strTimeout;
		strTimeout.Format(TEXT("%d Sec"), nTimeout);
		m_CEdit_WDT_Timeout.SetWindowText(strTimeout);
	}
	else
	{
		m_CEdit_WDT_Enable.SetWindowText(TEXT("?"));
		m_CEdit_WDT_Timeout.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab1::fnGetCANSwitchStatus()
{
	int nCANSwitchStatus;
	int nResult = GetCANSwitchStatus(&nCANSwitchStatus);
	if( nResult == 1 )
	{
		switch(nCANSwitchStatus)
		{
		case 0: m_CEdit_CANSwitchStatus.SetWindowText(TEXT("CAN2.0B")); break;
		case 1: m_CEdit_CANSwitchStatus.SetWindowText(TEXT("SAE J1939")); break;
		default: m_CEdit_CANSwitchStatus.SetWindowText(TEXT("Undefined")); break;
		}
	}
	else
	{
		m_CEdit_CANSwitchStatus.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab1::fnGetAudioSwitchStatus()
{
	int nAudioSwitchStatus;
	int nResult = GetAudioSwitchStatus(&nAudioSwitchStatus);
	if( nResult == 1 )
	{
		switch(nAudioSwitchStatus)
		{
		case 0: m_CEdit_AudioSwitchStatus.SetWindowText(TEXT("Driver")); break;
		case 1: m_CEdit_AudioSwitchStatus.SetWindowText(TEXT("Internal")); break;
		case 2: m_CEdit_AudioSwitchStatus.SetWindowText(TEXT("External")); break;
		default: m_CEdit_AudioSwitchStatus.SetWindowText(TEXT("Undefined")); break;
		}
	}
	else
	{
		m_CEdit_AudioSwitchStatus.SetWindowText(TEXT("?"));
	}
}

void CDialogConfigTab1::OnBnClickedButton1()
{
	int nWWAN_Enable = m_CComboBox_WWAN_Enable.GetCurSel();
	int nWWAN_Wakeup_Enable = m_CComboBox_WWAN_Wakeup_Enable.GetCurSel();

	int nResult = SetWWANControl(nWWAN_Enable, nWWAN_Wakeup_Enable);
	if( nResult == 1 )
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set WWAN Control Success."));

		fnGetWWANStatus();
	}
	else
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set WWAN Control Failed!!!"));
	}
}

void CDialogConfigTab1::OnBnClickedButton2()
{
	int nWiFi = m_CComboBox_WiFi.GetCurSel();

	int nResult = SetWiFiControl(nWiFi);
	if( nResult == 1 )
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set WiFi Control Success."));

		fnGetWiFiStatus();
	}
	else
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set WiFi Control Failed!!!"));
	}
}

void CDialogConfigTab1::OnBnClickedButton3()
{
	unsigned int nGPS_Enable  = m_CComboBox_GPS_Enable.GetCurSel();
	int nResult = SetGPSControl(nGPS_Enable);
	if( nResult == 1 )
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set GPS Control Success."));

		fnGetGPSStatus();
	}
	else
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set GPS Control Failed!!!"));
	}
}

void CDialogConfigTab1::OnBnClickedButton4()
{
	int nWDT_Enable = m_CComboBox_WDT_Enable.GetCurSel();
	int nResult = SetWatchdogControl(nWDT_Enable);
	if( nResult == 1 )
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set Watchdog Control Success."));

		fnGetWatchdogConfig();
	}
	else
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set Watchdog Control Failed!!!"));
	}
}

void CDialogConfigTab1::OnBnClickedButton5()
{
	int nWDT_TimeOut = m_CComboBox_WDT_Timeout.GetCurSel() + 3;
	int nResult = SetWatchdogTimer(nWDT_TimeOut);
	if( nResult == 1 )
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set Watchdog Timer Success."));

		fnGetWatchdogConfig();
	}
	else
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set Watchdog Timer Failed!!!"));
	}
}

void CDialogConfigTab1::OnBnClickedButton6()
{
	unsigned int nCANSwitch  = m_CComboBox_CANSwitch.GetCurSel();
	int nResult = SetCANSwitchControl(nCANSwitch);
	if( nResult == 1 )
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set CAN Switch Control Success."));

		fnGetCANSwitchStatus();
	}
	else
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set CAN Switch Control Failed!!!"));
	}
}

void CDialogConfigTab1::OnBnClickedButton7()
{
	unsigned int nAudioSwitch  = m_CComboBox_AudioSwitch.GetCurSel();
	int nResult = SetAudioSwitchControl(nAudioSwitch);
	if( nResult == 1 )
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set Audio Switch Control Success."));

		fnGetAudioSwitchStatus();
	}
	else
	{
		CVTC1020_UtilityDlg* p_MainDlg = (CVTC1020_UtilityDlg *)AfxGetMainWnd();
		if( p_MainDlg ) p_MainDlg->m_CEdit_Message.SetWindowText(TEXT("Set Audio Switch Control Failed!!!"));
	}
}

void CDialogConfigTab1::OnBnClickedButton8()
{
	m_CEdit_MCUversion.SetWindowText(TEXT(""));
	m_CEdit_Ignition.SetWindowText(TEXT(""));
	m_CEdit_SupplyVoltage.SetWindowText(TEXT(""));
	m_CEdit_InputFrequency.SetWindowText(TEXT(""));
	UpdateWindow();

	Update();
}

void CDialogConfigTab1::DoCommand()
{
	if( FALSE == m_isDoCommand )
	{
		m_isDoCommand = TRUE;
		m_nStep = 0;
		SetTimer(1, 0, NULL);
	}
}
