
// VTC1020_CAN_UtilityDlg.h : header file
//

#pragma once
#include "afxwin.h"


// CVTC1020_CAN_UtilityDlg dialog
class CVTC1020_CAN_UtilityDlg : public CDialog
{
// Construction
public:
	CVTC1020_CAN_UtilityDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_VTC1020_CAN_UTILITY_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT_PTR nIDEvent);

	void OnOK(){};

public:
	CComboBox m_CComboBox_CANSpeed;
	CComboBox m_CComboBox_FilterNumber;
	CEdit m_CEdit_FilterID;
	CEdit m_CEdit_FilterMaskID;
	CComboBox m_CComboBox_FilterMode;
	CComboBox m_CComboBox_FilterScale;
	CComboBox m_CComboBox_FilterActivation;
	CEdit m_CEdit_UserID;
	CComboBox m_CComboBox_Format;
	CComboBox m_CComboBox_Type;
	CComboBox m_CComboBox_Length;
	CEdit m_CEdit_CANMessage1;
	CEdit m_CEdit_CANMessage2;
	CEdit m_CEdit_CANMessage3;
	CEdit m_CEdit_CANMessage4;
	CEdit m_CEdit_CANMessage5;
	CEdit m_CEdit_CANMessage6;
	CEdit m_CEdit_CANMessage7;
	CEdit m_CEdit_CANMessage8;
	CEdit m_CEdit_Timer;
	CListBox m_CListBox_ReceiveCANMessage;
	CEdit m_CEdit_ErrorMessage;
	CEdit m_CEdit_TotalSend;
	CEdit m_CEdit_TotalErrorSend;
	CEdit m_CEdit_TotalReceive;

	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedButton2();
	afx_msg void OnBnClickedButton3();
	afx_msg void OnBnClickedButton4();
	afx_msg void OnBnClickedButton5();
	afx_msg void OnBnClickedButton6();
	afx_msg void OnBnClickedButton7();
	afx_msg void OnBnClickedButton8();

public:
	void MyRecevMessage();

	void AddErrorMessage(CString ErrorMessage);
	void AddRecevMessage(CString RecevMessage);

	void DisableButtonWhenClose();
	void EnableButtonWhenOpen();
};
